<?php
    
error_reporting(E_ERROR);
    
function localFilesInPath($p)
{
    $path = realpath($p);
    
    $objects = new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path),
                                             RecursiveIteratorIterator::SELF_FIRST);
    
    return $objects;
}
    
function fileToBeExcluded($f,$arr)
{
    foreach ($arr as $ex)
    {
        if (preg_match($ex,$f)) return true;
    }
    return false;
}
    
    function filecollect($ftp,$dir,$filelist) {

        $files = ftp_nlist($ftp,$dir); //get files in directory
        foreach ($files as $file) {
            $isfile = ftp_size($ftp, $file);
            if($isfile == "-1") { //Is a file or directory?
                $filelist = filecollect($ftp,$dir.'/'.$file,$filelist,$num); //If a folder, do a filecollect on it
            }
            else {
                $filelist[(count($filelist)+1)] = $file; //If not, add it as a file to the file list
            }
        }
        return $filelist;
    }
    
    function ftp_is_dir($dir) {
        global $ftp_connect;
        if (ftp_chdir($ftp_connect, $dir)) {
            ftp_chdir($ftp_connect, '..');
            return true;
        } else {
            return false;
        }
    }
    
function ftpRecursiveFileListing($ftpConnection, $path) {
    static $allFiles = array();
    $contents = ftp_nlist($ftpConnection, $path);
    
    foreach($contents as $currentFile) {
        // assuming its a folder if there's no dot in the name
        if (!ftp_is_dir($currentFile)) {
            ftpRecursiveFileListing($ftpConnection, $currentFile);
        }
        $allFiles[$path][] = substr($currentFile, strlen($path) + 1);
    } 
    return $allFiles; 
}
    
function remotedirectory($ftp, $directory, $basedir,$username,$password,$host)
{
    $files = ftp_nlist($ftp,$basedir.$directory);
    foreach($files as $key => $file)
    {
        if(is_dir("ftp://$username:$password@$host/".$basedir.$directory."/".$file))
        {
            $arrfile[] = remotedirectory($ftp, $directory."/".$file, basedir,$username,$password,$host);
        }else{
            $arrfile[] = $directory.'/'.$file;
        }
    }
    return $arrfile;
}
    
class FTP
{
    /* HELPERS */
    
    function sftpRecursivePut($sftp, $localFile, $localPath, $remotePath, $excluded)
    {
        $parts = pathinfo($localFile);
        $remoteFile = $parts['basename'];
        
        if (($remoteFile!=".") && ($remoteFile!="..") &&
            (!fileToBeExcluded($remoteFile, $excluded)))
        {
            $remoteFile = $remotePath.str_replace($localPath, "", $localFile);
            
            if (is_dir($localFile)) {
                // Directory
                
                if (!$sftp->file_exists($remoteFile))
                {
                    // Create it
                    echo "SFTP :: mkdir : $remoteFile\n";
                    $sftp->mkdir($remoteFile,-1,true);
                }
            }
            else {
                // File
                
                // Copy it
                echo "SFTP :: put : $remoteFile\n";
                $sftp->put($remoteFile, $localFile, NET_SFTP_LOCAL_FILE);
            }
        }
    }
    
    function ftpRecursivePut($ftp, $localFile, $localPath, $remotePath, $excluded)
    {
        $parts = pathinfo($localFile);
        $remoteFile = $parts['basename'];
        
        if (($remoteFile!=".") && ($remoteFile!="..") &&
            (!fileToBeExcluded($remoteFile, $excluded)))
        {
            $remoteFile = $remotePath.str_replace($localPath, "", $localFile);
            
            if (is_dir($localFile)) {
                // Directory
                
                
                if (!$ftp->fileExists($remoteFile))
                {
                    echo "FTP :: mkdir : $remoteFile\n";
                    // Create it
                    $ftp->mkDirRecursive($remoteFile);
                }
            }
            else {
                // File
                
                // Copy it
                echo "FTP :: put : $remoteFile\n";
                $ftp->put($remoteFile, $localFile, FTP_BINARY);
            }
        }
    }
    
    function sftpRecursiveGet($sftp, $remoteFile, $localPath, $remotePath, $excluded)
    {
       
        
        $parts = pathinfo($remoteFile);
        $baseName = $parts['basename'];
        
        if (($baseName!=".") && ($baseName!="..") &&
            (!fileToBeExcluded($baseName, $excluded)))
        {
            $localFile = $localPath."/".$remoteFile;
            $remoteFile = $remotePath.$remoteFile;
            
            
            if ($sftp->is_dir($remoteFile)) {
                // Directory
                
                if (file_exists($localFile))
                {
                    //echo "MKDIR: $localFile\n";
                    // Create it
                    mkdir($localFile,-1,true);
                }
            }
            else {
                // File
                
                $parts = pathinfo($localFile);
                $dir = $parts['dirname'];
                
                if (!file_exists($dir))
                {
                    mkdir($dir,-1,true);
                }
                
                // Copy it
                echo "FTP :: get : $remoteFile\n";
                $sftp->get($remoteFile, $localFile);
            }
        }
    }
    
    function ftpRecursiveGet($ftp, $remoteFile, $localPath, $remotePath, $excluded)
    {
        $parts = pathinfo($remoteFile);
        $baseName = $parts['basename'];
        
        if (($baseName!=".") && ($baseName!="..") &&
            (!fileToBeExcluded($baseName, $excluded)))
        {
            $localFile = $localPath."/".(str_replace($remotePath,"",$remoteFile));

            
            if ($ftp->isDir($remoteFile)) {
                // Directory
                
                if (file_exists($localFile))
                {
                    // Create it
                    mkdir($localFile,-1,true);
                }
            }
            else {
                // File
                
                $parts = pathinfo($localFile);
                $dir = $parts['dirname'];
                
                if (!file_exists($dir))
                {
                    mkdir($dir,-1,true);
                }
                
                // Copy it
                echo "FTP :: get : $remoteFile\n";
                $ftp->get($localFile, $remoteFile, FTP_BINARY);
            }
        }
    }
    
    /* MAIN ROUTINES */
    
    function syncLocalToRemote($argv,$localPath)
    {
        extract($argv);   
        
        if ($type=="sftp")
        {
            include 'phpseclib/Net/SFTP.php';
        
            $sftp = new Net_SFTP($host);
            if (!$sftp->login($username, $password)) 
            {
                exit("FTP :: Login failed with credentials (u: $username, p: $password)");
            }
            
            $locals = localFilesInPath($localPath);
            
            foreach($locals as $localFile => $object){
                self::sftpRecursivePut($sftp, $localFile, $localPath, $path, $excluded);
            }
            
            echo "FTP :: Upload finished.\n";
        }
        elseif ($type=="ftp")
        {
            try {
                include 'phpseclib/Ftp.php';
                $ftp = new Net_FTP;
                
                $ftp->connect($host);
                
                $ftp->login($username, $password);
                
                $locals = localFilesInPath($localPath);
                
                foreach($locals as $localFile => $object){
                    self::ftpRecursivePut($ftp, $localFile, $localPath, $path, $excluded);
                }
                
            }
            catch (FtpException $e) {
                echo 'FTP :: ', $e->getMessage();
            }
            
        }
        else {
            exit("FTP :: Unrecognized connection type ($type)");
        }
    }
    
    function syncRemoteToLocal($argv,$localPath)
    {
        extract($argv);
        
        if ($type=="sftp")
        {
            include 'phpseclib/Net/SFTP.php';
            
            $sftp = new Net_SFTP($host);
            if (!$sftp->login($username, $password))
            {
                exit("FTP :: Login failed with credentials (u: $username, p: $password)");
            }
            
            $remotes = $sftp->nlist($path,true);
            
            foreach ($remotes as $remote){
                self::sftpRecursiveGet($sftp, $remote, $localPath, $path, $excluded);
            }
            
            echo "FTP :: Download finished.\n";
        }
        elseif ($type=="ftp")
        {
            include 'phpseclib/Ftp.php';
            $ftp = new Net_FTP;
            
            $ftp->connect($host);
            
            $ftp->login($username, $password);
            
            $remotes = recNlist($ftp->resource, $path, "");
            
            foreach ($remotes as $remote){
                self::ftpRecursiveGet($ftp, $remote, $localPath, $path, $excluded);
            }
            
            echo "FTP :: Download finished.\n";
            
        }
        else {
            exit("FTP :: Unrecognized connection type ($type)");
        }
    }
    
    function listRemote($argv)
    {
        extract($argv);
        
        if ($type=="sftp")
        {
            include 'phpseclib/Net/SFTP.php';
        
            $sftp = new Net_SFTP($host);
            if (!$sftp->login($username, $password)) 
            {
                exit("FTP :: Login failed with credentials (u: $username, p: $password)");
            }
            
            $filelist = $sftp->nlist($path,true);
            
            foreach ($filelist as $file)
            {
                echo "$file\n";
            }
        }
        elseif ($type=="ftp")
        {
            try {
                $ftp = ftp_connect($host);
                
                ftp_login($ftp, $username, $password);

                $filelist = recNlist($ftp,$path,"");
                
                foreach ($filelist as $file)
                {
                    echo "$file\n";
                }
            }
            catch (FtpException $e) {
                echo 'FTP :: ', $e->getMessage();
            }

        }
        else {
            exit("FTP :: Unrecognized connection type ($type)");
        }
    }
    
}
    
    
function recNlist($ftp, $rootPath, $currentPath)
{
    $filelist = ftp_nlist($ftp,$rootPath."/".$currentPath);
    $results = array();
    
    foreach ($filelist as $file)
    {
        $filepath = $rootPath."/".$currentPath."/".$file;
        $filepath = preg_replace('/\/\//','',$filepath);
        
        $filetype = ftp_size($ftp, $filepath);
        
        if (($file!=".") && ($file!=".."))
        {
            if ($filetype==-1) // DIR
            {
                $results = array_merge($results, recNlist($ftp, $rootPath, $currentPath."/".$file));
            }
            else
                $results[] = $filepath;                
        }
        
        //echo $filepath;
        
        //if ($filetype==-1) echo " = DIR\n";
        //else echo "\n";
    }
    
    return $results;
}
    
$argz = json_decode($argv[1],true);
FTP::$argz[0]($argz[1],$argz[2]);

?>